const FILENAME = "userContent.css";
const BACKUP_FILENAME = "userContent-flashblock-backup.css";
const UC_PREFIX = "\n\n/* Begin FlashBlock */\n";
const UC_SUFFIX = "\n/* End FlashBlock */";

function writeUserContent()
{
    var du = new DirUtils();
    var profileDir = du.getMozUserHomeDir();

    var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
    dirLocal.initWithPath(profileDir);
    dirLocal.appendRelativePath("extensions");
    dirLocal.appendRelativePath("{3d7eb24f-2740-49df-8937-200b1cc08f8a}");
    dirLocal.append(FILENAME);

    var userContentSrc = new File(dirLocal.path);
    userContentSrc.open();
    var contents = userContentSrc.read();
    userContentSrc.close();

    var chromeDir = du.getUserChromeDir();
    dirLocal.initWithPath(chromeDir);
    dirLocal.append(FILENAME);

    var userContentDest = new File(dirLocal.path);
    userContentDest.open('a');
    var result = userContentDest.write(UC_PREFIX + contents + UC_SUFFIX);
    userContentDest.close();

    return result == JS_LIB_OK;
}

function removeUserContent()
{
    var success = false;

    var du = new DirUtils();
    var chromeDir = du.getUserChromeDir();

    var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
    dirLocal.initWithPath(chromeDir);
    dirLocal.append(FILENAME);

    var userContent = new File(dirLocal.path);

    if (userContent.exists()) {
        userContent.open();
        var contents = userContent.read();
        userContent.close();

        var startIndex = contents.indexOf(UC_PREFIX);
        var endIndex = contents.indexOf(UC_SUFFIX);

        if (startIndex != -1 && endIndex != -1) {
            var newContents = contents.substring(0, startIndex)
                                + contents.substring(endIndex + UC_SUFFIX.length);

            dirLocal.initWithPath(chromeDir);
            dirLocal.append(BACKUP_FILENAME);

            var userContentBackup = new File(dirLocal.path);
            userContentBackup.open('w');
            var result = userContentBackup.write(contents);
            userContentBackup.close();

            if (result == JS_LIB_OK)
            {
                userContent.open('w');
                result = userContent.write(newContents);
                userContent.close();
            }

            success = result == JS_LIB_OK;
        }
    } else {
        success = true;
    }

    return success;
}

function saveOptions()
{
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("flashblock.");
    var enabled = document.getElementById("status").selectedIndex == 0;

    if (prefs.getBoolPref("internalUse") != enabled) {
        var success = false;
        if (enabled) {
            success = writeUserContent();
        } else {
            success = removeUserContent();
        }

        if (success) {
            prefs.setBoolPref("internalUse", enabled);
            alert("The change will take effect when you restart your browser.");
        } else {
            alert("Error modifying userContent.css.");
        }
    }
}

function initializeOptions()
{
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("flashblock.");
    document.getElementById("status").selectedIndex = prefs.getBoolPref("internalUse") ? 0 : 1;
}
